# Configuring the Output Format for the Knowledge Navigator

The Output Format setting allows you to specify the format in which the **Knowledge Navigator** data will be exported. This setting is important for how you manage and analyze the data collected from the knowledge acquisition. Follow these steps to configure this option:

![Analysis](analysis.png)

1. **Output Format**:
   - **Description**: This setting allows you to select the format in which the chatbot’s data will be exported.
   - **Options**: 
     - `CSV`: Comma-Separated Values format, which is compatible with most spreadsheet and data analysis tools.
     - Other formats: Coming soon - JSON, XML, etc.
   - **Selection**: Choose `CSV` if you plan to use spreadsheet software like Microsoft Excel or Google Sheets for data analysis. Select other formats if they better suit your data processing workflows.

## Steps to Configure

1. Navigate to the Output Format setting of the Kognetiks Chatbot plugin in your WordPress dashboard.

2. Click on the dropdown menu next to `Output Format`.

3. Select your preferred format, such as `CSV`.

4. Click 'Save Settings' to apply your changes.

### Tips

- **Compatibility**: `CSV` is widely supported and easy to use with most data analysis tools, making it a good default choice.

- **Data Analysis**: Choose a format that aligns with your data analysis tools and processes. For example, use `CSV` for Excel or similar tools.

- **Future Use**: Consider how you might need to use the exported data in the future. Choosing a versatile format like CSV can make it easier to re-import or share the data later.

By configuring this setting, you ensure that the data collected from the knowledge acquisition process is exported in a format that best suits your needs for analysis and record-keeping.

---

- **[Back to the Overview](/overview.md)**
